/* randomvib1.c vibfunc.h  graph2d.h                       2005.9.01     */ 
/* Fourier transform of random wave and wave synthesis                   */
/* use Fourier(f,n,m,Fc,Fs) : f[0-n], Fc,Fs[0-m], n<601, m<=n/2          */
/* ? use double yy=ift(Fc,Fs,M,yy,n,k) : Fc,Fs[0-M], yy[k], total data n */
/* f[] : random wave data of 1DOF-vibration system response              */
/* Fc[],Fs[] : spectrum cos, sin   */
/* yy : k-th wave point in n data  */
/*
extern double ift();

//-------------- randomdatafileɏރ[` -------------//
main()
  {FILE*fp;   char fname[32];
   printf("\nfname(dnoise)="); scanf("%s",fname);
   fp=fopen(fname,"wt");
   printf("\n  fprintf during getch()=='n'  ");
   k=0;
p1:k++;
   random=1.0e-4*(rand()-16384);
   printf("\n  fprintf during getch()=='n'  ");
   printf("  k=%5d, %6.3f",k,random);
   j=getch();  if(j=='n') {fprintf(fp,"%lf\n",random); goto p1;}
   fclose(fp);

//--------- filedataǂݏoFourierϊ郋[` -----------------//
p3:max=0;kkk++;
   while(fscanf(fp,"%lf\n",&yy)==1) {f[max]=yy; max++; if(max>n) break;}
   ft1(f,n,Fc,Fs,m);
   Fmax=0;
   for(j=0;j<=m;j++)
     {F[j]=sqrt(Fc[j]*Fc[j]+Fs[j]*Fs[j]); if(Fmax<F[j]) Fmax=F[j];}
   if(kkk==1) km=1/Fmax;
}
*/



/************************************************************* 2005.12.7 *****/
//  randomvib1.c : PRx_O͂ɑ΂鉞̃V~[V        //
/*****************************************************************************/
#include    <stdio.h>
#include    <stdlib.h>
#include    <conio.h>
#include    <gl/glut.h>
#include    <math.h>
#include    <malloc.h>
#include    "graph2d9-24.h"
#include    "vibfunc11-23.h"

/****************************************************************************/
//       mainŒ`Cgraph2d.hŎg֐                                  //
/****************************************************************************/
void usrdisplay();
void usrkeyboard();
void usrtitle();
void motion_function();
/*****************************************************************************/

/**********************************************************************************/
//graph2d.hɂăCŎg֐
//   F`ŕKg֐@FAj[VŎg֐@Fv~eBu
/**********************************************************************************/
//usrRotateTranslate2d(rot, transx, transy);          //摜̉]{XΎւ̈ړ
//usrDrawLine2d(x1, y1, x2, y2, color[]);             // 
//usrDrawSolidCircle2d(r0[], a, color[]);             //hԂ~
//usrDrawSolidEllipse2d(r0[], a, b, alpha, color[]);  //hԂXΑȉ~
//usrDrawSolidRectangle2d(r0[], a, b, alpha, color[]);//hԂXΒ`
//usrDrawWireCircle2d(r0[], a, color[]);              //~
//usrDrawWireEllipse2d(r0[], a, b, alpha, color[]);   //XΑȉ~
//usrDrawWireRectangle2d(r0[], a, b, alpha, color[]); //XΒ`
//usrDrawArrow2d(r0[], a, alpha, color[]);            //
//usrDrawAxis2d(r0[], alpha);                         //_ƌXw肵(X,Y)
//usrGrating2d(r0[], alpha, n, wx, wy);               //(X,Y)ʂɊiqȂ`
//usrSetting();                                       //`̏ݒ                                  
//usrFlushAndSwap();                                  //`f[^`悷                 
//usrMotion();                                        //Aj[V̕ϐω
//glutIdleFunc(idle);                                 //Aj[V~߂
//glutIdleFunc( 0  );                                 //Aj[V𑱂
//DrawGL(int *count, char *argv[])                    //ʏ
//--------- graph2d.hɂϐ ------------------------------------------------//
//  float  red[]   ={1.0, 0.0, 0.0, 0.0};
//  float  green[] ={0.0, 1.0, 0.0, 0.0};
//  float  blue[]  ={0.0, 0.0, 1.0, 0.0};
//  float  yellow[]={1.0, 1.0, 0.0, 0.0};
//  float  black[] ={0.0, 0.0, 0.0, 0.0};
/**********************************************************************************/

#define   MMAX          601
#define   PAI           3.14159265358979
#define   RAD           1.745329252e-2
#define   DEG           5.72957795e1

static double mass, lamda, Kspring;  //}X(kg)C_p[(N/(m/s))C΂˒萔(N/m)
static double a, t, dt=0.01;
static double om0, OM0, zeta, zeta2;   //ŗLU(rad/s)CŗLUC
static double Force, Fex;              //O͕ϐU(N)Ct̂Ƃ̊O͐U
static double Amps, Ampd, Ampratio;    //Ý(m)CU(m)CU
double yy0, vv0, yy1[2], yy2[2], yseries[2][MMAX];
double Fexseries[MMAX];                //_O͂̎n
double Aseries[MMAX];                  //_̎n
double aseries[MMAX], phseries[MMAX];  //Pg̐UEʑ
double Ffrc[MMAX], Ffrs[MMAX], Afrc[MMAX], Afrs[MMAX];
double Ffrabs[MMAX], Afrabs[MMAX];     //XyNg
double GAmp[MMAX], GPhase[MMAX];       //`B֐/O
static double Ffr, Afr, Ffrav, Afrmax; //XyNg̕ϒlEől
static int    nrkg=2;                  //nrkg*dtRKGvZ
static int    nex, mex;                //Fourierϊf[^Eg̐
static int    nav;                     //nav̃XyNg𕽋ς
static int    n0;                      //0łP(2/0b)̃f[^
static double df, wfr;                 //_XyNg݁EXyNg}
static double wt, wy[2];               //ψʁExȐ̉݁Ec{
static int    mf=250, nf=1;            //g̉ݐCȐ
static double wf=0.02, wa, wp;         //gȐ̉݁Ec{
static double arrow0[2], arrowl, alpha, arrowd;
char      sgnf;                        //XyNg or `B֐`̑I
static double r0[2], rc[2], rf1[2], rf2[2]; //`挴_
double    r1[2], r2[2];
static int    m, n;
static int    MotionSign;
unsigned char KEY;
void   dialogue();
//double xedge=0.99;

/************** ̉ *********************************************/
double f(int i, double t, double y[], int cnt)
{
	static double yy;

	if(i==0) yy = y[1];
    if(i==1) { if(cnt==0)  Fex = Force*1.0e-4*(rand()-16384);
	           else        Fex = Fex;     //cnt=0̂ƂFexɕۂ
	           yy = (Fex - (lamda*y[1] + Kspring*y[0]) )/mass;
	}
	return yy;
}
/************* f() end *******************************************************/

/************* ǧvZ **********************************************/
//     wf݂ŁC0-m܂ł̐UɂĐUyy[]Eʑfi[]vZ               //
//     (f,y)ƂKĂ                                               //
/*****************************************************************************/
void freqcharct(double wf, int m, double yy[], double fi[])
{
	static double z, zz;
	static int    i;

	for(i=0;i<=m;i++)
	{
		z = i*wf;
		zz = z*z;
		if(fabs(z-1)<1.0e-6) { if(zeta==0) yy[i] = 1.0e5;  else yy[i] = 1/zeta2; fi[i] = 1; }
		else {
		yy[i] = 1.0/sqrt( (1 - zz)*(1 - zz) + zeta2*zeta2*zz );
		fi[i] = atan2( zeta2*z, (1 - zz) )*2/PAI;       //90=1Ƃ
		}
	}
}
/********* freqcharct() end ***************************************************/


/************************************************************************************/
int main(int argc, char *argv[])
{
//	static int i, m, n;
//	static double zeta0[]={0.0, 0.05, 0.1, 0.2, 0.5, 0.7071, 1.0, 2.0, 5.0};

	KEY = 'm';
	dialogue();

	DrawGL(&argc, argv);
}
/********* main() end ***********************************************************/

/*************** dialogue() *****************************************************/
void dialogue(void)
{
	static int i, j, k;

	if(KEY=='m')  goto d1;
	if(KEY=='n')  goto d2;
d1:
	printf("\nPRxUñ_mCYɑ΂鉞Ƃ̃XyNg̕`");
	printf("\nm*ddy/ddt + *dy/dt + K = f(t)=F*N(t)\n");
	printf("\n(1) n̒萔ݒ");
	printf("\n(2) _O͐Uݒ");
	printf("\n(3) XyNgvZς񐔐ݒ\n");
	printf("\n(1) }Xm[kg]C_p[[N/(m/s)]C΂˒萔K[N/m] L[ m  K=");
	scanf("%lf %lf %lf", &mass, &lamda, &Kspring);
	//------- ŗLUƌ ----------------------------//
    om0 = sqrt(Kspring/mass);
	zeta = lamda/(2*sqrt(mass*Kspring));	zeta2 = 2*zeta;
	if(zeta<=1)  OM0 = om0*sqrt(1 - zeta*zeta);
	printf("\nŗLU0=%7.4f[rad/s], =%7.4f",om0,zeta);
	if(zeta<=1) printf("\nŗLU=%7.4f[rad/s]",OM0);

	printf("\n\n(2) _UϐUFf L[ Ff[N]= ");
	scanf("%lf",&Force);
	Amps = Force/Kspring;
	Ampd = Force/ (lamda*om0);
	Ampratio = Ampd/Amps;
	printf("\nϐÝ As=%7.4f[m]",Amps);
	printf("\nUU @Ad=%7.4f[m]  UAd/As=%7.4f",Ampd,Ampratio);

	//------ ʏ̎g(50Ԗ=1/wf=1.0U_) ------------------------//
	wf = 0.02;  mf = 250;
    freqcharct(wf, mf, aseries, phseries);


    //-------- UvZFԂɂȂ܂ő҂ --------//
	yy2[0] = yy2[1] = 0.1;
    for(i=0;i<1000;i++)
	{
	    yy1[0] = yy2[0];
   	    yy1[1] = yy2[1];
    	disrkg( t, dt, yy1, yy2, 2, i);
        t = t + dt;
	}

d2:
	//-------------------------------------------------------------------------//
	//------ _ÓE̎g(50JԂĕςƂ) ---------//
	//-------------------------------------------------------------------------//
	//----- ̃XyNg𐳋K邽߂̏ ----------------//
	om0 = om0;                       //ŗLU[rad/s]
	n0 = 50;                         //U_܂ł̃XyNg
    df = om0/(2*PAI)/n0;             //XyNgݕ[Hz]
	mex = 4*n0;   nex = 2*mex;       //XyNgEf[^
	dt = 1.0/(nex*df)/nrkg;          //RKGlvZ̎ԍ
	//------ XyNg`ŉU_=1.0Ƃg -------//
	//---------------- I ---------------------------------------------//
	//-------- nav̃XyNg̕ ---------------------------//
    printf("\nUXyNgmex=%3d  gdf=%9.6f[Hz]  őg=%7.4f[Hz]"
		,mex,df,mex*df);
    printf("\n          f[^nex=%3d    ԍdt=%9.6fs     f[^ T=%7.4fs\n"
		,nex,nrkg*dt,nex*nrkg*dt);
	printf("\nTs̃f[^FourierϊăXyNg߁Cnavĕς\n");
	printf("\n(3) nav̃XyNg̕ςƂDL[ nav=");
	scanf("%d",&nav);
	printf("\nvZEEEEE");
    for(i=0;i<mex;i++)  Ffrabs[i] = Afrabs[i] = 0;
	for(k=0;k<nav;k++)
	{
       //-------- Ԃ̉nf[^Ƃ ---//
	   for(i=0;i<nex;i++)
	   {
		   //--- O͗Fexseries[]ɑ΂鉞Aseries[] ----//
            for(j=0;j<nrkg;j++)
			{
			   yy1[0] = yy2[0];
	           yy1[1] = yy2[1];
		       disrkg( t, dt, yy1, yy2, 2, j);
	           t = t + dt;
			}
      	    Fexseries[i] = Fex;
		    Aseries[i]   = yy2[0];
	   }
       //------- ÓẼXyNgnav̘a ----------//
	   FourierS(Fexseries, nex, mex, Ffrc, Ffrs);
	   FourierS(Aseries,   nex, mex, Afrc, Afrs);
 	   for(i=0;i<mex;i++)
	   {
	    	Ffr = sqrt(Ffrc[i]*Ffrc[i] + Ffrs[i]*Ffrs[i]); 
		    Afr = sqrt(Afrc[i]*Afrc[i] + Afrs[i]*Afrs[i]);
			//----- nav̘a -------------//
    	    Ffrabs[i] = Ffrabs[i] + Ffr;
    	    Afrabs[i] = Afrabs[i] + Afr;
	   }
	}
    for(i=0;i<mex;i++)
	   {
    	    Ffrabs[i] = Ffrabs[i]/nav/Force*12;
    	    Afrabs[i] = Afrabs[i]/nav*12*Kspring/Force;
			GAmp[i]   = Afrabs[i]/Ffrabs[i];
			GPhase[i] = ( atan2(Afrs[i], Afrc[i]) - atan2(Ffrs[i], Ffrc[i]) )*2/PAI;
			if(GPhase[i]<-2.0) GPhase[i] = GPhase[i] + 4.0;
	   }

	//------------ `̌_E{ ------------------------//
	r0[0] = 0.01;   r0[1] = 0;                  //{_
	rc[0] = -0.99;  rc[1] = 0;                  //UȐ_
    rf1[0] = r0[0];        rf1[1] = r0[1];      //XyNg_
    rf2[0] = r0[0];        rf2[1] = r0[1]-0.8;  //O̓XyNg_
	wt = 0.005;                //UȐԍ
	wy[0] = 0.5; wy[1] = 0.5;  //UȐc{
	wfr = 0.005;
    wf = 0.005;                //XyNg`扡
	wa = 0.5;                  //UXyNgc{
	wp = 0.3;                  //ʑXyNgc{
	//-------- ÓEXyNgE`B֐vZ end --------------------//

	printf("\n\n's'L[  FU`p");
	printf("\n'm'L[    F΂˃}XEOm,,KύX");
	printf("\n'n'L[    FςXyNǧnavύX");
	printf("\n'f' 'g'L[ŁFXyNgor`B֐`̑I");
	printf("\n'y' 'Y'L[ŁFUȐEXyNgc{ύX");
	printf("\nESCL[    FI\n");

	sgnf = 'f';
	yy2[0] = 0;
	yy2[1] = 0;
    t = 0;
	m = 0;
}
/************ dialogue() end ***********************************************/


/********************************************************************************/
//       `ʏ[Ƀ^Cg\
/********************************************************************************/
void usrtitle(void)
{
	glutCreateWindow("1DOF_U@m:΂˃}X́Cn:ω񐔁Cf,g:fGύX, s:Up");

 }

/*********************************************************************************/
//       `̏ݒE`e
/*********************************************************************************/
void usrdisplay(void)
{
	static int i;

	usrSetting();

	//-------- ̉(nrkg*dtbɃf[^Ƃ) ------//
	for(i=0;i<nrkg;i++)
	{
		yy1[0] = yy2[0];
	    yy1[1] = yy2[1];
		disrkg( t, dt, yy1, yy2, 2, i);
	    t = t + dt;
	}

//printf("\nmain() rkg()  m=%3d",m);
//printf("\n yy2[]=(%7.4f %7.4f)",yy2[0],yy2[1]);


	//---U}`Fr0[]_CwycCn}X̐Cyy2[0]U-------------------//
	drawfigure(r0, wy[0], 1, &yy2[0] );                          //}X̐U
	//-----------------O͂ŕ\ ----------------------------------------//
	arrowl = 0.1*Fex*wy[0];   alpha = PAI/2; arrowd = 0.05*wy[0];
	if(arrowl<0) { alpha = -alpha;   arrowd = -arrowd; }
	arrowl = fabs(arrowl);  
    arrow0[0] = r0[0] + 0.5*(xedge - r0[0]);       //̐[}X̏㉺0.2̈ʒu
	arrow0[1] = r0[1] + yy2[0]*wy[0] - arrowd;
	usrDrawArrow2d( arrow0, arrowl, alpha, green ); 
    //usrDrawArrow2d( double r0[], double a, double alpha, GLfloat color[] )
    //----- U} end ---------------------------------------------------------//

	//---Ȑ`Fr0[]_CwtԎCwy[]cCn{ȐCm̓_CUa[i][k]
    drawcharacter(-0.95, 0.95, H18, "red : response y(t)");                          //
    drawcharacter(-0.95, 0.90, H18, "blue: random force F(t)");                          //
	m++;  if( m > 1.0/wt ) m = 0;
	yseries[0][m] = yy2[0];
	yseries[1][m] = Fex/10;

	usrDrawAxis2d( rc, 0.0 );
	r1[0] = r0[0] - 200*wt;   r1[1] = r0[1];
    usrGrating( r1, 0.0, 10, 20*wt, 0.1 );
	drawcurve1( rc, wt, wy[0], m, yseries[0], red );               //UȐ
	drawcurve1( rc, wt, wy[1], m, yseries[1], blue);               //UȐ
    //----Ȑ` end ---------------------------------------------------------//

	//---XyNg`Frf[]_Cwfg݁Cwac{-----------------------//
	if(sgnf=='f')
	{
        drawcharacter(0.05,  0.95, H18, "spectrum of response |Y(jom)|");
        drawcharacter(0.05,  0.90, H18, "red    : simulation spectrum");
        drawcharacter(0.05,  0.85, H18, "green : theoretical spectrum");
        //------ _XyNg} --------------//
		drawcurve1(rf1, wfr, wa, mex, Afrabs, red);   //XyNg
		drawcurve1(rf1, wfr, wa, mf, aseries, green); //_IȃXyNg
		r2[0] = rf1[0]+2.0;   r2[1] = rf1[1];
        usrDrawLine2d(rf1, r2, red);        //XyNgX
		r1[0] = rf1[0]+n0*wf;   r1[1] = rf1[1];
		r2[0] = rf1[0]+n0*wf;   r2[1] = rf1[1] + 2.0;
        usrDrawLine2d(r1, r2, green);      //Ugc
        //------ _O̓XyNg} ----------------------//
        drawcharacter(0.05, -0.05, H18, "spectrum of random force |F(jom)|");                          //
        drawcharacter(0.05, -0.10, H18, "blue: simulation,   green:theory");                          //
		drawcurve1(rf2, wfr, wa, mex, Ffrabs, blue);
		r2[0] = rf2[0]+2.0;   r2[1] = rf2[1];
        usrDrawLine2d(rf2, r2, blue);       //O̓XyNgX
		r1[0] = rf2[0];       r1[1] = rf2[1] + wa;
		r2[0] = rf2[0]+2.0;   r2[1] = rf2[1] + wa;
        usrDrawLine2d(r1, r2, green);       //O͕σXyNg
//void usrDrawLine2d(double r1[], double r2[], GLfloat color[4])
	}
	if(sgnf=='g')
	{
        drawcharacter(0.05, 0.95, H18, "amplitute charcteristics of system |G(jom)|");                          //
        drawcharacter(0.05, 0.90, H18, "red:simulation,   green:theory");                          //
        //------ _IȌn̐Ug} ----------//
		drawcurve1(rf1, wf,  wa, mf, aseries, green);
        //------ Ug} --------------------//
		drawcurve1(rf1, wfr, wa, mex, GAmp, red);
		r2[0] = rf1[0]+2.0;   r2[1] = rf1[1];
        usrDrawLine2d(rf1, r2, black);       //UgX
		r1[0] = rf1[0]+n0*wf;   r1[1] = rf1[1];
		r2[0] = rf1[0]+n0*wf;   r2[1] = rf1[1] + 2.0;
        usrDrawLine2d(r1, r2, green);      //Ugc
        //------ _IȌn̈ʑg} ----------//
        drawcharacter(0.05, -0.10, H18, "phase charcteristics of system arg(G(jom))");                          //
        drawcharacter(0.05, -0.15, H18, "red:simulation,    green:theory");                          //
  	    r1[0] = r0[0];        r1[1] = r0[1]-0.2;
		drawcurve1(r1, wf,  -wp, mf, phseries, green);
        //------ ʑg} --------------------//
		drawcurve1(r1, wfr, -wp, mex, GPhase, red);
		r2[0] = r1[0]+2.0;   r2[1] = r1[1];
        usrDrawLine2d(r1, r2, green);       //ʑg̃=0
  	    r1[0] = r0[0];       r1[1] = r0[1]-0.2-wp;
		r2[0] = r1[0]+2.0;   r2[1] = r1[1];
        usrDrawLine2d(r1, r2, green);       //ʑg̃=90
  	    r1[0] = r0[0];       r1[1] = r0[1]-0.2-2*wp;
		r2[0] = r1[0]+2.0;   r2[1] = r1[1];
        usrDrawLine2d(r1, r2, green);       //ʑg̃=180
	}

	usrFlushAndSwap();
}
/*********** usrdisplay() end ***********************************************/

/****************************************************************************/
//   L[ɂĕ`̐؂ւEI
/****************************************************************************/
void usrkeyboard(unsigned char key, int x, int y)
{
	KEY = key;

	if(key=='s')
	{
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='m' || key=='n')
	{
		t = 0;
		MotionSign = 0; 	dialogue();
		goto end;
	}
	if(key=='t' || key=='T')
	{
		if(key=='t')  wt = 0.9*wt; 
		if(key=='T')  wt = wt/0.9;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}
	if(key=='y' || key=='Y')
	{
		if(key=='y') { wa = 0.9*wa;  wy[0] = wy[1] = 0.9*wy[0]; } 
		if(key=='Y')  { wa = wa/0.9; wy[0] = wy[1] = wy[0]/0.9; }
		MotionSign = 0; 	usrdisplay();
		goto end;
	}

	if(key=='f' || key=='g')
	{
		sgnf = key;
		MotionSign = 0; 	usrdisplay();
		goto end;
	}

	if(key=='\033')   exit(0);

end:;
}



void motion_function(void){ }
